
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MessagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.create(
            {
                id: data.id || undefined,
        
        message_type: data.message_type
        ||
        null
            ,
            
        message_text: data.message_text
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        is_read: data.is_read
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await messages.setChat_thread( data.chat_thread || null, {
            transaction,
        });
        
        await messages.setSender_user( data.sender_user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: messages.id,
            },
            data.attachment_files,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_images',
                belongsToId: messages.id,
            },
            data.attachment_images,
            options,
        );
        

        return messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                message_type: item.message_type
            ||
            null
            ,
            
                message_text: item.message_text
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                is_read: item.is_read
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const messages = await db.messages.bulkCreate(messagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.messages.getTableName(),
                    belongsToColumn: 'attachment_files',
                    belongsToId: messages[i].id,
                },
                data[i].attachment_files,
                options,
            );
        }
        
        for (let i = 0; i < messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.messages.getTableName(),
                    belongsToColumn: 'attachment_images',
                    belongsToId: messages[i].id,
                },
                data[i].attachment_images,
                options,
            );
        }
        

        return messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const messages = await db.messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.message_type !== undefined) updatePayload.message_type = data.message_type;
        
        
        if (data.message_text !== undefined) updatePayload.message_text = data.message_text;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.is_read !== undefined) updatePayload.is_read = data.is_read;
        
        
        updatePayload.updatedById = currentUser.id;

        await messages.update(updatePayload, {transaction});

        
        
        if (data.chat_thread !== undefined) {
            await messages.setChat_thread(
              
              data.chat_thread,
              
              { transaction }
            );
        }
        
        if (data.sender_user !== undefined) {
            await messages.setSender_user(
              
              data.sender_user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_files',
                belongsToId: messages.id,
            },
            data.attachment_files,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.messages.getTableName(),
                belongsToColumn: 'attachment_images',
                belongsToId: messages.id,
            },
            data.attachment_images,
            options,
        );
        

        return messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of messages) {
                await record.destroy({transaction});
            }
        });


        return messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findByPk(id, options);

        await messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await messages.destroy({
            transaction
        });

        return messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findOne(
            { where },
            { transaction },
        );

        if (!messages) {
            return messages;
        }

        const output = messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.chat_thread = await messages.getChat_thread({
            transaction
        });
        
        
        output.sender_user = await messages.getSender_user({
            transaction
        });
        
        
        output.attachment_files = await messages.getAttachment_files({
            transaction
        });
        
        
        output.attachment_images = await messages.getAttachment_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.chat_threads,
        as: 'chat_thread',
        
        where: filter.chat_thread ? {
          [Op.or]: [
            { id: { [Op.in]: filter.chat_thread.split('|').map(term => Utils.uuid(term)) } },
            {
              thread_title: {
                [Op.or]: filter.chat_thread.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'sender_user',
        
        where: filter.sender_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sender_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachment_files',
      },

      {
        model: db.file,
        as: 'attachment_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'messages',
                        'message_text',
                        filter.message_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.message_type) {
                where = {
                    ...where,
                message_type: filter.message_type,
            };
            }
            
            if (filter.is_read) {
                where = {
                    ...where,
                is_read: filter.is_read,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'messages',
                        'message_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.messages.findAll({
            attributes: [ 'id', 'message_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message_text,
        }));
    }

    
};

